import { View } from 'tns-core-modules/ui/core/view';
export declare abstract class TNSCanvasBase extends View {
    abstract getContext(type: string): TNSCanvasRenderingContext | null;
}
export interface TNSCanvasRenderingContext {
}
export declare abstract class TNSCanvasRenderingContext2DBase implements TNSCanvasRenderingContext {
    lineWidth: number;
    fillStyle: string | CanvasGradientBase;
    strokeStyle: string | CanvasGradientBase;
    lineCap: string;
    globalCompositeOperation: string;
    font: string;
    globalAlpha: number;
    imageSmoothingEnabled: boolean;
    imageSmoothingQuality: string;
    lineDashOffset: number;
    lineJoin: string;
    miterLimit: number;
    shadowBlur: number;
    shadowColor: string;
    shadowOffsetX: number;
    shadowOffsetY: number;
    textAlign: string;
    abstract addHitRegion(region: any): void;
    abstract arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
    abstract beginPath(): void;
    abstract bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
    abstract clearHitRegions(): void;
    abstract clearRect(x: number, y: number, width: number, height: number): void;
    abstract clip(): void;
    abstract clip(fillRule: string): void;
    abstract clip(path: any, fillRule: string): void;
    abstract closePath(): void;
    abstract createImageData(width: number, height: number): ImageDataBase;
    abstract createImageData(data: ImageDataBase): ImageDataBase;
    abstract createLinearGradient(x0: number, y0: number, x1: number, y1: number): any;
    abstract createPattern(image: any, repetition: string): any;
    abstract createRadialGradient(x0: number, y0: number, r0: number, x1: number, y1: number, r1: number): any;
    abstract drawFocusIfNeeded(element: any): void;
    abstract drawFocusIfNeeded(path: any, element: any): void;
    abstract drawImage(image: any, dx: number, dy: number): void;
    abstract drawImage(image: any, dx: number, dy: number, dWidth: number, dHeight: number): void;
    abstract drawImage(image: any, sx: number, sy: number, sWidth: number, sHeight: number, dx: number, dy: number, dWidth: number, dHeight: number): void;
    abstract ellipse(x: number, y: number, radiusX: number, radiusY: number, rotation: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract fill(fillRule?: string): void;
    abstract fill(path: TNSPath2DBase, fillRule: string): void;
    abstract fillRect(x: number, y: number, width: number, height: number): void;
    abstract fillText(text: string, x: number, y: number, maxWidth?: number): void;
    abstract getImageData(sx: number, sy: number, sw: number, sh: number): ImageDataBase;
    abstract getLineDash(): number[];
    abstract isPointInPath(x: number, y: number, fillRule: string): boolean;
    abstract isPointInPath(path: TNSPath2DBase, x: number, y: number, fillRule: string): boolean;
    abstract isPointInStroke(x: number, y: number): boolean;
    abstract isPointInStroke(path: TNSPath2DBase, x: number, y: number): boolean;
    abstract lineTo(x: number, y: number): void;
    abstract measureText(text: string): TextMetricsBase;
    abstract moveTo(x: number, y: number): void;
    abstract putImageData(imageData: ImageDataBase, dx: number, dy: number): void;
    abstract putImageData(imageData: ImageDataBase, dx: number, dy: number, dirtyX: number, dirtyY: number, dirtyWidth: number, dirtyHeight: number): void;
    abstract quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): any;
    abstract rect(x: number, y: number, width: number, height: number): void;
    abstract removeHitRegion(id: string): void;
    abstract resetTransform(): void;
    abstract restore(): void;
    abstract rotate(angle: number): void;
    abstract save(): void;
    abstract scale(x: number, y: number): void;
    abstract scrollPathIntoView(): void;
    abstract scrollPathIntoView(path: TNSPath2DBase): void;
    abstract setLineDash(segments: number[]): void;
    abstract setTransform(a: number, b: number, c: number, d: number, e: number, f: number): void;
    abstract stroke(): void;
    abstract stroke(path: TNSPath2DBase): void;
    abstract strokeRect(x: number, y: number, width: number, height: number): void;
    abstract strokeText(text: string, x: number, y: number, maxWidth?: number): void;
    abstract transform(a: number, b: number, c: number, d: number, e: number, f: number): void;
    abstract translate(x: number, y: number): void;
}
export declare abstract class TNSPath2DBase {
    abstract addPath(path: TNSPath2DBase, transform?: any): void;
    abstract closePath(): void;
    abstract moveTo(x: number, y: number): void;
    abstract lineTo(x: number, y: number): void;
    abstract bezierCurveTo(cp1x: number, cp1y: number, cp2x: number, cp2y: number, x: number, y: number): void;
    abstract quadraticCurveTo(cpx: number, cpy: number, x: number, y: number): void;
    abstract arc(x: number, y: number, radius: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract arcTo(x1: number, y1: number, x2: number, y2: number, radius: number): void;
    abstract ellipse(x: number, y: number, radiusX: number, radiusY: number, rotation: number, startAngle: number, endAngle: number, anticlockwise: boolean): void;
    abstract rect(x: number, y: number, width: number, height: number): void;
}
export declare class ImageDataBase {
    protected nativeInstance: any;
    constructor(nativeInstance: any);
    width: number;
    height: number;
    data: any;
    readonly native: any;
}
export declare abstract class CanvasGradientBase {
    abstract addColorStop(offset: number, color: any): void;
}
export declare abstract class CanvasPattern {
}
export declare class TextMetricsBase {
    protected nativeInstance: any;
    constructor(nativeInstance: any);
}
